#include <stdio.h>
#include <stdlib.h>

#include "Pilha.h"

void criarPilha(TPilha **p)
{
	*p = NULL;
}

void empilhar(TPilha **p, Tipo valor)
{
	TPilha *aux;
	aux = (TPilha *) malloc(sizeof(TPilha));
	aux->info = valor;
	aux->prox = *p;
	*p = aux;  
}

void imprime(TPilha *p)
{
	printf("{");
	while (p != NULL)
	{
		printf("%c ", p->info);
		p = p->prox;
	}
	printf("\b}\n");
}

Tipo desempilhar(TPilha **p)
{
	TPilha *aux = *p;
  if (aux == NULL)
  {
    printf("Pilha vazia...\n");
    exit(1);
  }
  int resposta = aux->info;
  *p = aux->prox;
  free(aux);
  return resposta;
}

int estaVazia(TPilha *p)
{
	return p == NULL;
}

Tipo topo(TPilha *p)
{
	return p->info;
}
